this.author      = "spara"; 
this.copyright   = "2014 spara"; 
this.description = "Respawn asteroids to keep the numbers in balance"; 
this.licence 	 = "CC-BY-SA 3.0";
this.name        = "asteroid_respawn";
this.version     = "1.0";

//how far from the player to spawn
this.$minimumDistance = 500E3;

this.startUpComplete = this.shipExitedWitchspace = function() {
	this.$asteroidsTotal = system.countShipsWithPrimaryRole("asteroid");
}

//replace destroyed asteroids when docking.
this.shipDockedWithStation = function(station) {
	var difference = this.$asteroidsTotal - system.countShipsWithPrimaryRole("asteroid");
	if (difference > 0) {
		//report asteroids over min distance away from player
		function $findAsteroids(entity){
			if (entity.primaryRole === "asteroid")
				if (entity.position.distanceTo(player.ship.position) > this.$minimumDistance)
					return true;
			return false;
		}
		var asteroids = system.filteredEntities(this, $findAsteroids, player.ship);
		//Add field only if it can be added around an asteroid far away enough
		if (asteroids.length > 0) {
			var spawnPosition = asteroids[Math.floor(Math.random(asteroids.length))].position;
			//add asteroids as a cloud
			system.addShips("asteroid", difference, spawnPosition);
		}
		//In case there's no suitable asteroid to be used as a spawn position, spread 'em around the player
		else {
			for (var i = 0; i < difference; i++) {
				var spawnPosition = player.ship.position.add(Vector3D.randomDirection(this.$minimumDistance)).multiply(1 + Math.random());
				system.addShips("asteroid", 1, spawnPosition);
			}
		}
	}
}
